;;;; message-digest-bv.scm
;;;; Kon Lovett, Jan '06 (message-digest.scm)
;;;; Kon Lovett, May '10 (message-digest.scm)
;;;; Kon Lovett, Apr '12
;;;; Kon Lovett, Aug '17

;; Issues

(module message-digest-bv

(;export
  ;
  message-digest-update-blob
  message-digest-update-string
  message-digest-update-substring  ;DEPRECATED
  message-digest-blob
  message-digest-string)

(import scheme)

(import
  chicken
  (only srfi-13 substring/shared))
(require-library
  srfi-13)

(import
  (only type-checks
    check-blob check-string))
(require-library
  type-checks)

(require-extension
  message-digest-primitive
  message-digest-type
  message-digest-support)

;;; Message Digest API

;; Update

;;

(define (message-digest-update-blob md blb)
  (*message-digest-update-blob
    (check-message-digest 'message-digest-update-blob md)
    (check-blob 'message-digest-update-blob blb)) )

;;

(define (message-digest-update-string md str)
  (*message-digest-update-string
    (check-message-digest 'message-digest-update-string md)
    (check-string 'message-digest-update-string str)) )

;;

;DEPRECATED
(define (message-digest-update-substring md str start end)
  (*message-digest-update-string
    (check-message-digest 'message-digest-update-substring md)
    (substring/shared (check-string 'message-digest-update-substring str) start end)) )

;; Single Source API

(define (message-digest-string mdp str #!optional (result-type (message-digest-default-result-type)))
  (let ((md (initialize-message-digest mdp)))
    (message-digest-update-string md str)
    (finalize-message-digest md result-type) ) )

(define (message-digest-blob mdp blb #!optional (result-type (message-digest-default-result-type)))
  (let ((md (initialize-message-digest mdp)))
    (message-digest-update-blob md blb)
    (finalize-message-digest md result-type) ) )

) ;module message-digest-bv
